Files

147 lines
6.0 KiB
Bash
Raw Permalink Normal View History

2023-07-04 10:28:19 +08:00
#!/usr/bin/env bash
2023-07-04 11:15:20 +08:00
# Copyright © 2023 OpenIM. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
2023-07-04 10:28:19 +08:00
2023-07-04 12:29:31 +08:00
2023-07-04 10:28:19 +08:00
# -----------------------------------------------------------------------------
# Version management helpers. These functions help to set, save and load the
# following variables:
#
2023-07-04 11:15:20 +08:00
# OPENIM_GIT_COMMIT - The git commit id corresponding to this
2023-07-04 10:28:19 +08:00
# source code.
2023-07-04 11:15:20 +08:00
# OPENIM_GIT_TREE_STATE - "clean" indicates no changes since the git commit id
2023-07-04 10:28:19 +08:00
# "dirty" indicates source code changes after the git commit id
# "archive" indicates the tree was produced by 'git archive'
2023-07-04 11:15:20 +08:00
# OPENIM_GIT_VERSION - "vX.Y" used to indicate the last release version.
# OPENIM_GIT_MAJOR - The major part of the version
# OPENIM_GIT_MINOR - The minor component of the version
2023-07-04 10:28:19 +08:00
# Grovels through git to set a set of env variables.
#
2023-07-04 11:15:20 +08:00
# If OPENIM_GIT_VERSION_FILE, this function will load from that file instead of
2023-07-04 10:28:19 +08:00
# querying git.
2023-07-04 11:15:20 +08:00
openim::version::get_version_vars() {
if [[ -n ${OPENIM_GIT_VERSION_FILE-} ]]; then
openim::version::load_version_vars "${OPENIM_GIT_VERSION_FILE}"
2023-07-04 10:28:19 +08:00
return
fi
# If the iamrnetes source was exported through git archive, then
# we likely don't have a git tree, but these magic values may be filled in.
# shellcheck disable=SC2016,SC2050
# Disabled as we're not expanding these at runtime, but rather expecting
# that another tool may have expanded these and rewritten the source (!)
if [[ '$Format:%%$' == "%" ]]; then
2023-07-04 11:15:20 +08:00
OPENIM_GIT_COMMIT='$Format:%H$'
OPENIM_GIT_TREE_STATE="archive"
2023-07-04 10:28:19 +08:00
# When a 'git archive' is exported, the '$Format:%D$' below will look
# something like 'HEAD -> release-1.8, tag: v1.8.3' where then 'tag: '
# can be extracted from it.
if [[ '$Format:%D$' =~ tag:\ (v[^ ,]+) ]]; then
2023-07-04 11:15:20 +08:00
OPENIM_GIT_VERSION="${BASH_REMATCH[1]}"
2023-07-04 10:28:19 +08:00
fi
fi
2023-07-04 11:15:20 +08:00
local git=(git --work-tree "${OPENIM_ROOT}")
2023-07-04 10:28:19 +08:00
2023-07-04 11:15:20 +08:00
if [[ -n ${OPENIM_GIT_COMMIT-} ]] || OPENIM_GIT_COMMIT=$("${git[@]}" rev-parse "HEAD^{commit}" 2>/dev/null); then
if [[ -z ${OPENIM_GIT_TREE_STATE-} ]]; then
2023-07-04 10:28:19 +08:00
# Check if the tree is dirty. default to dirty
if git_status=$("${git[@]}" status --porcelain 2>/dev/null) && [[ -z ${git_status} ]]; then
2023-07-04 11:15:20 +08:00
OPENIM_GIT_TREE_STATE="clean"
2023-07-04 10:28:19 +08:00
else
2023-07-04 11:15:20 +08:00
OPENIM_GIT_TREE_STATE="dirty"
2023-07-04 10:28:19 +08:00
fi
fi
# Use git describe to find the version based on tags.
2023-07-04 11:15:20 +08:00
if [[ -n ${OPENIM_GIT_VERSION-} ]] || OPENIM_GIT_VERSION=$("${git[@]}" describe --tags --always --match='v*' 2>/dev/null); then
2023-07-04 10:28:19 +08:00
# This translates the "git describe" to an actual semver.org
# compatible semantic version that looks something like this:
# v1.1.0-alpha.0.6+84c76d1142ea4d
#
# TODO: We continue calling this "git version" because so many
# downstream consumers are expecting it there.
#
# These regexes are painful enough in sed...
# We don't want to do them in pure shell, so disable SC2001
# shellcheck disable=SC2001
2023-07-04 11:15:20 +08:00
DASHES_IN_VERSION=$(echo "${OPENIM_GIT_VERSION}" | sed "s/[^-]//g")
2023-07-04 10:28:19 +08:00
if [[ "${DASHES_IN_VERSION}" == "---" ]] ; then
# shellcheck disable=SC2001
# We have distance to subversion (v1.1.0-subversion-1-gCommitHash)
2023-07-04 11:15:20 +08:00
OPENIM_GIT_VERSION=$(echo "${OPENIM_GIT_VERSION}" | sed "s/-\([0-9]\{1,\}\)-g\([0-9a-f]\{14\}\)$/.\1\+\2/")
2023-07-04 10:28:19 +08:00
elif [[ "${DASHES_IN_VERSION}" == "--" ]] ; then
# shellcheck disable=SC2001
# We have distance to base tag (v1.1.0-1-gCommitHash)
2023-07-04 11:15:20 +08:00
OPENIM_GIT_VERSION=$(echo "${OPENIM_GIT_VERSION}" | sed "s/-g\([0-9a-f]\{14\}\)$/+\1/")
2023-07-04 10:28:19 +08:00
fi
2023-07-04 11:15:20 +08:00
if [[ "${OPENIM_GIT_TREE_STATE}" == "dirty" ]]; then
2023-07-04 10:28:19 +08:00
# git describe --dirty only considers changes to existing files, but
# that is problematic since new untracked .go files affect the build,
# so use our idea of "dirty" from git status instead.
# TODO?
2023-07-04 11:15:20 +08:00
#OPENIM_GIT_VERSION+="-dirty"
2023-07-04 10:28:19 +08:00
:
fi
# Try to match the "git describe" output to a regex to try to extract
# the "major" and "minor" versions and whether this is the exact tagged
# version or whether the tree is between two tagged versions.
2023-07-04 11:15:20 +08:00
if [[ "${OPENIM_GIT_VERSION}" =~ ^v([0-9]+)\.([0-9]+)(\.[0-9]+)?([-].*)?([+].*)?$ ]]; then
OPENIM_GIT_MAJOR=${BASH_REMATCH[1]}
OPENIM_GIT_MINOR=${BASH_REMATCH[2]}
2023-07-04 10:28:19 +08:00
if [[ -n "${BASH_REMATCH[4]}" ]]; then
2023-07-04 11:15:20 +08:00
OPENIM_GIT_MINOR+="+"
2023-07-04 10:28:19 +08:00
fi
fi
2023-07-04 11:15:20 +08:00
# If OPENIM_GIT_VERSION is not a valid Semantic Version, then refuse to build.
if ! [[ "${OPENIM_GIT_VERSION}" =~ ^v([0-9]+)\.([0-9]+)(\.[0-9]+)?(-[0-9A-Za-z.-]+)?(\+[0-9A-Za-z.-]+)?$ ]]; then
echo "OPENIM_GIT_VERSION should be a valid Semantic Version. Current value: ${OPENIM_GIT_VERSION}"
2023-07-04 10:28:19 +08:00
echo "Please see more details here: https://semver.org"
exit 1
fi
fi
fi
}
# Saves the environment flags to $1
2023-07-04 11:15:20 +08:00
openim::version::save_version_vars() {
2023-07-04 10:28:19 +08:00
local version_file=${1-}
[[ -n ${version_file} ]] || {
2023-07-04 11:15:20 +08:00
echo "!!! Internal error. No file specified in openim::version::save_version_vars"
2023-07-04 10:28:19 +08:00
return 1
}
cat <<EOF >"${version_file}"
2023-07-04 11:15:20 +08:00
OPENIM_GIT_COMMIT='${OPENIM_GIT_COMMIT-}'
OPENIM_GIT_TREE_STATE='${OPENIM_GIT_TREE_STATE-}'
OPENIM_GIT_VERSION='${OPENIM_GIT_VERSION-}'
OPENIM_GIT_MAJOR='${OPENIM_GIT_MAJOR-}'
OPENIM_GIT_MINOR='${OPENIM_GIT_MINOR-}'
2023-07-04 10:28:19 +08:00
EOF
}
# Loads up the version variables from file $1
2023-07-04 11:15:20 +08:00
openim::version::load_version_vars() {
2023-07-04 10:28:19 +08:00
local version_file=${1-}
[[ -n ${version_file} ]] || {
2023-07-04 11:15:20 +08:00
echo "!!! Internal error. No file specified in openim::version::load_version_vars"
2023-07-04 10:28:19 +08:00
return 1
}
source "${version_file}"
}